<template>
    <div class="list-view">
        <page-title>
            <!-- <el-button
                @click="addRow"
                type="primary"
                icon="el-icon-plus"
                :disabled="fetchingData || downloading"
                class="filter-item"
            >
                新增
            </el-button>
            <el-button
                @click="download"
                icon="el-icon-upload2"
                :loading="downloading"
                :disabled="fetchingData"
                class="filter-item"
            >
                导出
            </el-button> -->
        </page-title>
        <div class="filters-container">
            <el-input
                placeholder="搜索昵称..."
                v-model="search"
                clearable
                class="filter-item search"
                @keyup.enter.native="getData"
            >
                <el-button @click="getData" slot="append" icon="el-icon-search"> </el-button>
            </el-input>
            <el-radio-group v-model="status" @change="getData">
                <el-radio-button v-for="item in statusOptions" :label="item.value" :key="item.value">{{
                    item.label
                }}</el-radio-button>
            </el-radio-group>
        </div>
        <el-table
            :data="tableData"
            row-key="id"
            ref="table"
            header-row-class-name="table-header-row"
            header-cell-class-name="table-header-cell"
            row-class-name="table-row"
            cell-class-name="table-cell"
            :height="tableHeight"
            v-loading="fetchingData"
        >
            <el-table-column v-if="multipleMode" align="center" type="selection" width="50"> </el-table-column>
            <el-table-column prop="id" label="ID" width="100"> </el-table-column>
            <el-table-column prop="userId" label="用户ID"> </el-table-column>
            <el-table-column prop="nickname" label="昵称"> </el-table-column>
            <el-table-column prop="pic" label="logo">
                <template slot-scope="{ row }">
                    <el-image
                        style="width: 30px; height: 30px"
                        :src="row.pic"
                        fit="cover"
                        :preview-src-list="[row.pic]"
                    ></el-image>
                </template>
            </el-table-column>
            <el-table-column prop="introduction" label="简介"> </el-table-column>
            <el-table-column prop="likes" label="点赞"> </el-table-column>
            <el-table-column prop="sort" label="排序"></el-table-column>
            <!-- <el-table-column prop="maxCollection" label="最多可放藏品数量"> </el-table-column> -->
            <!-- <el-table-column prop="headBg" label="头部背景">
                <template slot-scope="{ row }">
                    <el-image
                        style="width: 30px; height: 30px"
                        :src="row.headBg"
                        fit="cover"
                        :preview-src-list="[row.headBg]"
                    ></el-image>
                </template>
            </el-table-column>
            <el-table-column prop="showroomBg" label="展厅背景">
                <template slot-scope="{ row }">
                    <el-image
                        style="width: 30px; height: 30px"
                        :src="row.showroomBg"
                        fit="cover"
                        :preview-src-list="[row.showroomBg]"
                    ></el-image>
                </template>
            </el-table-column> -->
            <el-table-column prop="status" label="状态" :formatter="statusFormatter"> </el-table-column>
            <el-table-column label="操作" align="center" fixed="right" width="210">
                <template slot-scope="{ row, $index }">
                    <el-button @click="editRow(row)" type="primary" size="mini" plain>查看</el-button>
                    <!-- <el-button @click="deleteRow(row)" type="danger" size="mini" plain>删除</el-button> -->
                    <el-button
                        @click="pass(row, $index)"
                        type="success"
                        size="mini"
                        plain
                        v-if="row.status === 'PENDING'"
                        :loading="row.saving"
                    >
                        通过
                    </el-button>
                    <el-button
                        @click="deny(row, $index)"
                        type="danger"
                        size="mini"
                        plain
                        v-if="row.status === 'PENDING'"
                        :loading="row.saving"
                    >
                        拒绝
                    </el-button>
                </template>
            </el-table-column>
        </el-table>
        <div class="pagination-wrapper">
            <!-- <div class="multiple-mode-wrapper">
                <el-button v-if="!multipleMode" @click="toggleMultipleMode(true)">批量编辑</el-button>
                <el-button-group v-else>
                    <el-button @click="operation1">批量操作1</el-button>
                    <el-button @click="operation2">批量操作2</el-button>
                    <el-button @click="toggleMultipleMode(false)">取消</el-button>
                </el-button-group>
            </div> -->
            <el-pagination
                background
                @size-change="onSizeChange"
                @current-change="onCurrentChange"
                :current-page="page"
                :page-sizes="[10, 20, 30, 40, 50]"
                :page-size="pageSize"
                layout="total, sizes, prev, pager, next, jumper"
                :total="totalElements"
            >
            </el-pagination>
        </div>

        <el-dialog :visible.sync="showReasonDialog" width="600px" title="拒绝理由">
            <el-form ref="denyForm" :model="denyForm" label-position="right" label-width="60px" :rules="denyRules">
                <el-form-item prop="reason" label="理由">
                    <el-input type="textarea" :autosize="{ minRows: 3 }" v-model="denyForm.reason"></el-input>
                </el-form-item>
            </el-form>
            <div slot="footer">
                <el-button @click="showReasonDialog = false">取消</el-button>
                <el-button type="primary" @click="saveReason">保存</el-button>
            </div>
        </el-dialog>
    </div>
</template>
<script>
import { mapState } from 'vuex';
import pageableTable from '@/mixins/pageableTable';

export default {
    name: 'ShowroomList',
    mixins: [pageableTable],
    data() {
        return {
            multipleMode: false,
            search: '',
            url: '/showroom/all',
            downloading: false,
            statusOptions: [
                { label: '审核中', value: 'PENDING' },
                { label: '失败', value: 'FAIL' },
                { label: '已成功', value: 'SUCCESS' },
                { label: '未审核', value: 'NOT_AUTH' }
            ],
            showReasonDialog: false,
            denyForm: {},
            denyRules: {
                reason: [{ required: true, message: '请填写理由' }]
            },
            status: 'PENDING',
            saving: false
        };
    },
    computed: {
        selection() {
            return this.$refs.table.selection.map(i => i.id);
        }
    },
    methods: {
        afterGetData(res) {
            this.tableData = res.content.map(item => {
                return {
                    ...item,
                    saving: false
                };
            });
        },
        statusFormatter(row, column, cellValue, index) {
            let selectedOption = this.statusOptions.find(i => i.value === cellValue);
            if (selectedOption) {
                return selectedOption.label;
            }
            return '';
        },
        beforeGetData() {
            return {
                sort: 'sort,desc;id,desc',
                search: this.search,
                query: { del: false, type: 'COMPANY', status: this.status }
            };
        },
        toggleMultipleMode(multipleMode) {
            this.multipleMode = multipleMode;
            if (!multipleMode) {
                this.$refs.table.clearSelection();
            }
        },
        addRow() {
            this.$router.push({
                path: '/showroomEdit',
                query: {
                    ...this.$route.query
                }
            });
        },
        editRow(row) {
            this.$router.push({
                path: '/showroomEdit',
                query: {
                    id: row.id
                }
            });
        },
        download() {
            this.downloading = true;
            this.$axios
                .get('/showroom/excel', {
                    responseType: 'blob',
                    params: { size: 10000 }
                })
                .then(res => {
                    console.log(res);
                    this.downloading = false;
                    const downloadUrl = window.URL.createObjectURL(new Blob([res.data]));
                    const link = document.createElement('a');
                    link.href = downloadUrl;
                    link.setAttribute('download', res.headers['content-disposition'].split('filename=')[1]);
                    document.body.appendChild(link);
                    link.click();
                    link.remove();
                })
                .catch(e => {
                    console.log(e);
                    this.downloading = false;
                    this.$message.error(e.error);
                });
        },
        operation1() {
            this.$notify({
                title: '提示',
                message: this.selection
            });
        },
        operation2() {
            this.$message('操作2');
        },
        deleteRow(row) {
            this.$alert('删除将无法恢复，确认要删除么？', '警告', { type: 'error' })
                .then(() => {
                    return this.$http.post(`/showroom/del/${row.id}`);
                })
                .then(() => {
                    this.$message.success('删除成功');
                    this.getData();
                })
                .catch(e => {
                    if (e !== 'cancel') {
                        this.$message.error(e.error);
                    }
                });
        },
        pass(row, index) {
            this.tableData[index].saving = true;
            this.$confirm('确定通过？')
                .then(res => {
                    return this.$http.post('/showroom/pass', { id: row.id });
                })
                .then(res => {
                    this.$message.success('成功');
                    this.tableData[index].saving = false;
                    this.getData();
                })
                .catch(e => {
                    this.tableData[index].saving = false;
                });
        },
        deny(row, index) {
            this.showReasonDialog = true;
            this.denyForm.id = row.id;
            this.denyForm.index = index;
        },
        saveReason() {
            this.tableData[this.denyForm.index].saving = true;
            this.$confirm('确定拒绝？')
                .then(res => {
                    return this.$http.post('/showroom/deny', {
                        id: this.denyForm.id,
                        reason: this.denyForm.reason
                    });
                })
                .then(res => {
                    this.$message.success('成功');
                    this.showReasonDialog = false;
                    this.tableData[this.denyForm.index].saving = false;
                    this.getData();
                })
                .catch(e => {
                    this.tableData[this.denyForm.index].saving = false;
                });
        }
    }
};
</script>
<style lang="less" scoped>
</style>
